% Exemplo de discretizao de espao de estados

% Planta
G  = zpk([],[0,-1],1);
S  = ss(G);

% Discretizao
T = 0.1;
Sd = c2d(S,0.1,'zoh');

% Resposta impulsiva
t  = 0:0.01:5;
td = 0:0.1:5;

y  = impulse(S,t);
yd = impulse(Sd,td);

% Grfico
figure(1); clf
plot(t,y,'r','linewidth',2)
hold on
stairs(td,yd,'b','linewidth',2)
hold off

title('Resposta Impulsiva')
ylabel('y(t) , y(k)')
xlabel('t (s)')
legend('Contnuo','Discreto','Location','Southeast')
grid
