% Realimentao de estado com feedforward (exemplo 1)

% Seja a planta
G  = zpk([],[0,-1],1);
S  = ss(G);

% Discretizao
T = 0.1;
Sdy = c2d(S,0.1,'zoh');
Sdx = Sdy; Sdx.c = eye(2); % Fazendo C=I para ter acesso ao estado

Phi   = Sdy.a;
Gamma = Sdy.b;
C     = Sdy.c;

% Polos desejados
qsi = 0.45;
wn  = 2;
so  = roots([1 2*qsi*wn wn^2]);
zo  = exp(so*T);

% Controle
K = place(Phi,Gamma,zo)

% Sistema em malha fechada

% Pr filtros
F   = inv([ (Phi-eye(2)) Gamma ; C 0 ])*[ zeros(2,1) ; 1 ];
Fxl = F(1:2,1)
Fu  = F(3,1)
Fx  = -K*Fxl

% Simulao
sim('ex_sf_ff_1_sim');
% A simulao 


% Grfico
figure(1)
clf
stairs(tsim,xsim,'-o')
hold on
stairs(tsim,xrsim(:,1),'-b','linewidth',1.5)
stairs(tsim,xrsim(:,2),'-r','linewidth',1.5)
grid
legend('x_{1}(t) = y(t)','x_{2}(t) = dy(t)/dt','x_{1r}','x_{2r}')
xlabel('t (s)')
ylabel('x(t)')
title('Resposta ao degrau da malha fechada')