% Realimentao de estado com feedforward (exemplo 2)

% Seja a planta discreta
Phi   = [0.7 -0.3 ; 0.1 0.5];
Gamma = eye(2);
C     = [1 0];
D     = zeros(1,2);
T     = 0.1
S  = ss(Phi,Gamma,C,D,T);
Sx = ss(Phi,Gamma,eye(2),zeros(2),T);


% Polos desejados
qsi = 0.9021;
wn  = 10.726;
so  = roots([1 2*qsi*wn wn^2]);
zo  = exp(so*T);

% Controle
K = place(Phi,Gamma,zo)

% Sistema em malha fechada sem pr-filtro e feedforward
Fxl = eye(2);
Fu  = zeros(2);
% Simulao
sim('ex_sf_ff_3_sim');
% Grfico
figure(1)
clf
stairs(tsim,xsim,'-o')
hold on
stairs(tsim,xrsim(:,1),'-b','linewidth',1.5)
stairs(tsim,xrsim(:,2),'-r','linewidth',1.5)
axis([0 2 0 1.2])
grid
legend('x_{1}(t)','x_{2}(t)','location','southeast')
xlabel('t (s)')
ylabel('x(t)')
title('Resposta ao degrau da malha fechada (sem filtros)')


% Pr filtros
F   = inv([ (Phi-eye(2)) Gamma ; C zeros(1,2) ])*[ zeros(2) ; eye(1) ];
Fxl = F(1:2,1:2)
Fu  = F(3:4,1:2)
Fx  = -K*Fxl

% Simulao
sim('ex_sf_ff_3_sim');
% A simulao 


% Grfico
figure(2)
clf
stairs(tsim,xsim,'-o')
hold on
stairs(tsim,xrsim(:,1),'-b','linewidth',1.5)
stairs(tsim,xrsim(:,2),'-r','linewidth',1.5)
axis([0 2 0 1.2])
grid
legend('x_{1}(t)','x_{2}(t)','x_{1r} = 1','x_{2r} = 1','location','southeast')
xlabel('t (s)')
ylabel('x(t)')
title('Resposta ao degrau da malha fechada (com filtros)')